import * as Mc from "@minecraft/server"
import * as Ui from "@minecraft/server-ui"
const World = Mc.world


let max_health
Mc.world.events.playerJoin.subscribe((eventData) => {
    try { Mc.world.getDimension('overworld').runCommandAsync(`scoreboard objectives add "unitx:ban" dummy`) } catch (e) { }
})
World.events.beforeChat.subscribe((eventData) => {
    if (World.getDynamicProperty("withdraw") == true) {
        if ((eventData.message.startsWith('!withdraw') || eventData.message.startsWith('!wd')) && !eventData.sender.hasTag('dead')) {
            eventData.cancel = true
            let mes = eventData.message.replace(/\D/g, '')
            mes = parseInt(mes)
            mes = Math.round(mes)
            if (mes < 1) {
                eventData.sender.sendMessage(`§cinvalid amount of hearts specified!`)
                return
            }
            if (isNaN(mes)) { eventData.sender.sendMessage(`\§cInvaild syntax! §7Useage !wd 1-50`) }
            else {
                let player = eventData.sender
                getmax(player)
                if (mes < (max_health / 2)) {
                    let mes2 = Math.floor(max_health / 2) - mes
                    try { player.triggerEvent(`unitx:health${mes2}`) } catch (e) { return }
                    player.runCommandAsync(`give @s unitx:heart ${mes}`)
                    eventData.sender.sendMessage(`§aYou have withdrawn §7${Math.round(mes)} §ahearts`)
                }
                else {
                    eventData.sender.sendMessage(`§cInsufficient amount of hearts gain more hearts to withdraw §7${mes} §chearts!`)
                }
            }
        }
    }
    if (World.getDynamicProperty("!banned") == true && (eventData.message == '!banned' || eventData.message == '!bn')) {
        eventData.cancel = true

        let banned_players = Mc.world.scoreboard.getObjective('unitx:ban').getParticipants()
        if (banned_players.length !== 0) {
            let names = undefined
            for (let i = 0; i < banned_players.length; i++) {
                if (i == 0) names = banned_players[i].displayName.replace('banned:', '').replace(':end_select', '')
                else names = names + "," + banned_players[i].displayName.replace(`banned: `).replace(`: end_select`)
            }
            if (names == undefined) eventData.sender.sendMessage(`§cNo banned players found!`)
            else eventData.sender.sendMessage(`§cBanned players: §7${names} `)
        }
        else {
            eventData.sender.sendMessage(`§cNo banned players found!`)
        }
    }
    if (World.getDynamicProperty("!spectorors") == true && (eventData.message == '!spectorors' || eventData.message == '!sp')) {
        eventData.cancel = true
        const players = Array.from(World.getPlayers({ gameMode: "spectator" }), p => p.name)
        if (players.length == 0) {
            eventData.sender.sendMessage(`§cNo spectorors online!`)
            return
        }
        eventData.sender.sendMessage(`§cspectorors: §7${players} `)
    }
})

Mc.system.run(async function tick() {
    Mc.system.run(tick)
    for (const player of Mc.world.getPlayers()) {
        if (player.hasTag('unitx:ban')) {
            let banned_players = Mc.world.scoreboard.getObjective('unitx:ban').getParticipants()
            if (banned_players.length !== 0) {
                let found = false
                for (let i = 0; i < banned_players.length; i++) {
                    if (banned_players[i].displayName.includes("banned:" + player.name + ":end_select")) {
                        player.runCommandAsync(`kick ${player.name} §cYou have lost your last life and now are banned!`)
                        found = true
                        break
                    }
                }
                if (found == false) {
                    player.removeTag('unitx:ban')
                    player.triggerEvent(`unitx:health${World.getDynamicProperty("respawn_hearts")} `)
                }
            }
        }
        if (player.hasTag('unitx:heart')) {
            player.removeTag('unitx:heart')
            getmax(player)
            if ((max_health / 2) < World.getDynamicProperty("max_health")) {
                player.triggerEvent(`unitx:health${Math.floor(max_health / 2) + 1}`)
                player.runCommandAsync(`clear @s unitx:heart -1 1`)
            }
            else { player.sendMessage(`§cMax health reached!`) }
        }
        if ((player.getComponent('health').current / 2) > World.getDynamicProperty("max_health")) {
            player.triggerEvent(`unitx:health${Math.round(World.getDynamicProperty("max_health"))} `)
        }
        if (player.hasTag('unitx:settings')) {
            player.removeTag('unitx:settings')
            let main = new Ui.ActionFormData()
            main.title('menu'),
                main.button('Settings', "textures/items/book_writable"),
                main.button('Reviving', "textures/blocks/deadbush"),
                main.button('Unbaning', "textures/blocks/barrier"),
                main.button('Credits', "textures/blocks/ender_chest_front")
            main.button('Extras', "textures/items/cake")
            main.show(player).then((respond) => {
                if (respond.selection == 0) {
                    let form = new Ui.ModalFormData()
                    form.title('Settings')
                    form.slider('Starting hearts', 1, 50, 1, World.getDynamicProperty("starting_health"))
                    form.slider('Max Hearts', 1, 50, 1, World.getDynamicProperty("max_health"))
                    form.slider('Hearts gained when you kill', 0, 25, 1, World.getDynamicProperty("health_gain"))
                    form.slider('Hearts lost when you die', 0, 25, 1, World.getDynamicProperty("health_lose"))
                    form.toggle('You lose hearts anytime you die', World.getDynamicProperty("environmental_deaths"))
                    form.toggle('Enable !withdraw & !wd', World.getDynamicProperty("withdraw"))
                    form.toggle('Drop a soul when you lose your last heart', World.getDynamicProperty("drop_souls"))
                    form.slider('Revive beacon base size needed', 0, 4, 1, World.getDynamicProperty("beacon_base"))
                    form.slider('Hearts given when Revived/Unbanned', 0, 50, 1, World.getDynamicProperty("respawn_hearts"))
                    form.dropdown('when you lose your last heart', ['ban', 'spectator'], World.getDynamicProperty("after_last_life"))
                    form.show(player).then((respond) => {
                        if (respond.isCanceled) return;
                        let r = respond.formValues
                        World.setDynamicProperty("starting_health", r[0])
                        World.setDynamicProperty("max_health", r[1])
                        World.setDynamicProperty("health_gain", r[2])
                        World.setDynamicProperty("health_lose", r[3])
                        World.setDynamicProperty("environmental_deaths", r[4])
                        World.setDynamicProperty("withdraw", r[5])
                        World.setDynamicProperty("drop_souls", r[6])
                        World.setDynamicProperty("beacon_base", r[7])
                        World.setDynamicProperty("respawn_hearts", r[8])
                        World.setDynamicProperty("after_last_life", r[9])
                    })
                }
                if (respond.selection == 4) {
                    let form = new Ui.ModalFormData()
                    form.title('Settings')
                    form.toggle('Enable random starting hearts', World.getDynamicProperty("random hearts"))
                    form.slider('Max starting hearts', 1, 50, 1, World.getDynamicProperty("max random hearts"))
                    form.slider('Min starting hearts', 1, 50, 1, World.getDynamicProperty("min random hearts"))
                    form.toggle('Enable !banned & !bn', World.getDynamicProperty("!banned"))
                    form.toggle('Enable !spectorors & !sp', World.getDynamicProperty("!spectorors"))
                    form.show(player).then((respond) => {
                        if (respond.isCanceled) return;
                        let r = respond.formValues
                        if (r[1] < r[2] && r[0] == true) {
                            player.sendMessage(`§cMaximum hearts can't be lower than Minimum hearts`)
                            return
                        }
                        World.setDynamicProperty("random hearts", r[0])
                        World.setDynamicProperty("max random hearts", r[1])
                        World.setDynamicProperty("min random hearts", r[2])
                        World.setDynamicProperty("!banned", r[3])
                        World.setDynamicProperty("!spectorors", r[4])
                    })
                }
                if (respond.selection == 3) {
                    let credits = new Ui.ActionFormData()
                    credits.title('Credits')
                    credits.body('§7Made by §cUnitX\n\n§7Need help? §7Join my §9Discord\n§7https://discord.gg/krRXAdddgk\n\n§7Need a tutorial/info on settings? \n§cVist my youtube §7https://www.youtube.com/channel/UCUKB2Klf2Nkfi8reaxmdo0w')
                    credits.button('§cClose')
                    credits.show(player)
                }
                if (respond.selection == 1) {
                    let rev = new Ui.ModalFormData()
                    rev.title('Reviving')
                    const players = Array.from(World.getPlayers({ gameMode: "spectator" }), p => p.name)
                    const players_data = Array.from(World.getPlayers({ gameMode: "spectator" }))
                    if (players.length == 0) {
                        player.sendMessage(`§cNo died players online to revive!`)
                        return
                    }
                    rev.dropdown('Player to revive', players, 0)
                    rev.slider('Hearts', 1, 50, 1, World.getDynamicProperty("respawn_hearts"))
                    rev.show(player).then((respond) => {
                        if (respond.isCanceled) return;
                        let r = respond.formValues
                        players_data[r[0]].teleport(player.location, player.dimension, 0, 0, false)
                        players_data[r[0]].runCommandAsync(`gamemode s @s`)
                        players_data[r[0]].removeTag("spectorator")
                        players_data[r[0]].triggerEvent(`unitx:health${r[1]}`)
                        players_data[r[0]].addEffect(Mc.MinecraftEffectTypes.weakness, 30, 255, false)
                        player.sendMessage(`§7You have revived §a${players[r[0]]} §7with §c${r[1]} §7hearts`)
                    })
                }
                if (respond.selection == 2) {
                    let ban = new Ui.ModalFormData()
                    ban.title('Unbanning players')
                    ban.textField('', 'Players name:')
                    ban.show(player).then((respond) => {
                        if (respond.isCanceled) return;
                        let banned_players = Mc.world.scoreboard.getObjective('unitx:ban').getParticipants()
                        if (banned_players.length == 0) {
                            player.sendMessage(`§cNo banned players with the name §7${respond.formValues[0]} §cfound!`)
                        }
                        else {
                            for (let i = 0; i < banned_players.length; i++) {
                                if (!banned_players[i].displayName.includes("banned:" + respond.formValues[0] + ":end_select")) {
                                    player.sendMessage(`§cNo banned players with the name §7${respond.formValues[0]} §cfound!`)
                                    continue
                                }
                                try { player.runCommandAsync(`scoreboard players reset "banned:${respond.formValues[0]}:end_select" "unitx:ban"`) } catch (error) { }
                                player.sendMessage(`§7Unbanned §a${respond.formValues[0]}`)
                                break
                            }
                        }

                    })
                }
            })
        }
        if (!(player.hasTag('starting_health'))) {
            if (World.getDynamicProperty("random hearts") == true) {
                const ran = Math.floor(Math.random() * (World.getDynamicProperty("max random hearts") - World.getDynamicProperty("min random hearts")) + World.getDynamicProperty("min random hearts"));
                player.runCommandAsync(`event entity @s unitx:health${ran}`)
                player.addTag('starting_health')
            }
            player.runCommandAsync(`event entity @s unitx:health${World.getDynamicProperty("starting_health")}`)
            player.addTag('starting_health')
        }
    }
})
Mc.world.events.entityHurt.subscribe((eventData) => {
    if (eventData.hurtEntity.getComponent('health').current > 0 || eventData.hurtEntity.typeId !== "minecraft:player") return//runs if they don't die
    getmax(eventData.hurtEntity)
    if (Math.floor(max_health / 2) - World.getDynamicProperty("health_lose") > 0) {//runs if they can respawn after they are killed
        let damager_type
        if (eventData.damageSource.damagingEntity == undefined) damager_type = undefined
        else damager_type = eventData.damageSource.damagingEntity.typeId
        if (World.getDynamicProperty("environmental_deaths") == false && damager_type == "minecraft:player") {
            eventData.hurtEntity.triggerEvent(`unitx:health${Math.floor(max_health / 2) - World.getDynamicProperty("health_lose")}`)
        }
        if (World.getDynamicProperty("environmental_deaths") == true) {
            eventData.hurtEntity.triggerEvent(`unitx:health${Math.floor(max_health / 2) - World.getDynamicProperty("health_lose")}`)
        }
    }
    else {//runs when they lose there last heart
        if (World.getDynamicProperty("drop_souls") == true) {
            eventData.hurtEntity.dimension.spawnItem(new Mc.ItemStack(Mc.Items.get("unitx:revive_soul")), new Mc.Vector(eventData.hurtEntity.location.x, eventData.hurtEntity.location.y, eventData.hurtEntity.location.z));
        }
        eventData.hurtEntity.triggerEvent(`unitx:health${World.getDynamicProperty("starting_health")}`)
        if (World.getDynamicProperty("after_last_life") == 1) {
            eventData.hurtEntity.addTag("spectorator")
            eventData.hurtEntity.runCommandAsync(`gamemode spectator @s`)
        }
        if (World.getDynamicProperty("after_last_life") == 0) {
            eventData.hurtEntity.addTag(`unitx:ban`)
            try { eventData.hurtEntity.runCommandAsync(`scoreboard players add "banned:${eventData.hurtEntity.name}:end_select" "unitx:ban" 0`) } catch (error) {
                eventData.hurtEntity.runCommandAsync(`scoreboard objectives add "unitx:ban" dummy`)
                eventData.hurtEntity.runCommandAsync(`scoreboard players add "banned:${eventData.hurtEntity.name}:end_select" "unitx:ban" 0`)
            }
        }
    }
    if (eventData.damageSource.damagingEntity == undefined) return
    getmax(eventData.damageSource.damagingEntity)
    if ((World.getDynamicProperty("health_gain") + (max_health / 2)) <= World.getDynamicProperty("max_health")) {
        eventData.damageSource.damagingEntity.triggerEvent(`unitx:health${Math.round(World.getDynamicProperty("health_gain") + (max_health / 2))}`)
    }
    else if ((World.getDynamicProperty("health_gain") + (max_health / 2)) > World.getDynamicProperty("max_health")) {
        eventData.damageSource.damagingEntity.triggerEvent(`unitx:health${World.getDynamicProperty("max_health")}`)
        eventData.damageSource.damagingEntity.sendMessage(`§cMax health reached!`)
    }
})
function getmax(player) {
    let health = player.getComponent('health').current
    player.getComponent('health').resetToMaxValue()
    max_health = player.getComponent('health').current
    player.getComponent('health').setCurrent(health)
}
World.events.worldInitialize.subscribe((eventData => {
    const dy = new Mc.DynamicPropertiesDefinition()
    dy.defineNumber("starting_health")
    dy.defineNumber("max_health")
    dy.defineNumber("health_gain")
    dy.defineNumber("health_lose")
    dy.defineBoolean("environmental_deaths")
    dy.defineBoolean("withdraw")
    dy.defineNumber("after_last_life")
    dy.defineBoolean("spectorors")
    dy.defineBoolean("banned")
    dy.defineNumber("respawn_hearts")
    dy.defineBoolean("drop_souls")
    dy.defineNumber("beacon_base")
    dy.defineBoolean("!banned")
    dy.defineBoolean("!spectorors")
    dy.defineBoolean("random hearts")
    dy.defineNumber("max random hearts")
    dy.defineNumber("min random hearts")
    eventData.propertyRegistry.registerWorldDynamicProperties(dy)
    if (World.getDynamicProperty("starting_health") == undefined) { World.setDynamicProperty("starting_health", 10) }
    if (World.getDynamicProperty("max_health") == undefined) { World.setDynamicProperty("max_health", 30) }
    if (World.getDynamicProperty("health_gain") == undefined) { World.setDynamicProperty("health_gain", 1) }
    if (World.getDynamicProperty("health_lose") == undefined) { World.setDynamicProperty("health_lose", 1) }
    if (World.getDynamicProperty("environmental_deaths") == undefined) { World.setDynamicProperty("environmental_deaths", true) }
    if (World.getDynamicProperty("withdraw") == undefined) { World.setDynamicProperty("withdraw", true) }
    if (World.getDynamicProperty("after_last_life") == undefined) { World.setDynamicProperty("after_last_life", 1) }
    if (World.getDynamicProperty("spectorors") == undefined) { World.setDynamicProperty("spectorors", false) }
    if (World.getDynamicProperty("banned") == undefined) { World.setDynamicProperty("banned", false) }
    if (World.getDynamicProperty("respawn_hearts") == undefined) { World.setDynamicProperty("respawn_hearts", World.getDynamicProperty("starting_health")) }
    if (World.getDynamicProperty("drop_souls") == undefined) { World.setDynamicProperty("drop_souls", true) }
    if (World.getDynamicProperty("beacon_base") == undefined) { World.setDynamicProperty("beacon_base", 1) }

    if (World.getDynamicProperty("!banned") == undefined) { World.setDynamicProperty("!banned", false) }
    if (World.getDynamicProperty("!spectorors") == undefined) { World.setDynamicProperty("!spectorors", false) }
    if (World.getDynamicProperty("random hearts") == undefined) { World.setDynamicProperty("random hearts", false) }

    if (World.getDynamicProperty("max random hearts") == undefined) { World.setDynamicProperty("max random hearts", 15) }
    if (World.getDynamicProperty("min random hearts") == undefined) { World.setDynamicProperty("min random hearts", 5) }
}))
World.events.beforeItemUseOn.subscribe((eventData => {
    if (Mc.world.getDimension("overworld").getBlock(eventData.getBlockLocation()).typeId !== "unitx:revive_beacon" || eventData.source.isSneaking == true) return
    let layer_read = Mc.world.getDynamicProperty("beacon_base")
    for (let i = 0; i < Mc.world.getDynamicProperty("beacon_base"); i++) {
        let block = eventData.getBlockLocation()
        let blocks = blocksBetween(block.x - layer_read, block.y - layer_read, block.z - layer_read, block.x + layer_read, block.y - layer_read, block.z + layer_read)
        for (let i = 0; i < blocks.length; i++) {
            let block = Mc.world.getDimension("overworld").getBlock(new Mc.Vector(blocks[i][0], blocks[i][1], blocks[i][2])).typeId
            if (!((block == "minecraft:gold_block") || (block == "minecraft:iron_block") || (block == "minecraft:diamond_block") || (block == "minecraft:emerald_block") || (block == "minecraft:netherite_block"))) {
                eventData.source.sendMessage(`§cInvaild Beacon Base!`)
                return
            }
        }
        layer_read--
    }
    let has = 0
    let inv = eventData.source.getComponent("minecraft:inventory").container;
    for (let i = 0; i < inv.size; i++) {
        let item = inv.getItem(i)
        if (!item) continue
        if (item.typeId == "unitx:revive_soul") {
            has = 1
            break
        }
    }
    if (has == 0) eventData.source.sendMessage(`§cA soul is requred!`)
    if (has == 1) {
        let player = eventData.source
        let main = new Ui.ActionFormData()
        main.title('Reviving!')
        main.button('Reviving', "textures/blocks/deadbush")
        main.button('Unbaning', "textures/blocks/barrier")
        main.show(player).then((respond) => {
            if (respond.selection == 1) {
                let ban = new Ui.ModalFormData()
                ban.title('Unbanning players')
                ban.textField('', 'Players name:')
                ban.show(player).then((respond) => {
                    if (respond.isCanceled) return;
                    let banned_players = Mc.world.scoreboard.getObjective('unitx:ban').getParticipants()
                    if (banned_players.length !== 0) {
                        let found = false
                        for (let i = 0; i < banned_players.length; i++) {
                            if (banned_players[i].displayName.includes("banned:" + respond.formValues[0] + ":end_select")) {
                                try { player.runCommandAsync(`scoreboard players reset "banned:${respond.formValues[0]}:end_select" "unitx:ban"`) } catch (error) { }
                                try {
                                    player.runCommandAsync(`clear @s unitx:revive_soul 0 1`)
                                    player.sendMessage(`§7Unbanned §a${respond.formValues[0]}`)
                                    player.runCommandAsync(`playsound ambient.weather.thunder @a`)
                                } catch (error) { }
                                found = true
                                break
                            }
                        }
                        if (found == false) {
                            player.sendMessage(`§cNo banned players with the name §7${respond.formValues[0]} §cfound!`)
                            return
                        }
                    } else {
                        player.sendMessage(`§cNo banned players with the name §7${respond.formValues[0]} §cfound!`)
                        return
                    }
                })
            }
            if (respond.selection == 0) {
                let rev = new Ui.ModalFormData()
                rev.title('Reviving')
                const players = Array.from(Mc.world.getPlayers({ gameMode: "spectator" }), p => p.name)
                const players_data = Array.from(World.getPlayers({ gameMode: "spectator" }))
                if (players.length == 0) {
                    player.sendMessage(`§cNo died players online to revive!`)
                    return
                }
                rev.dropdown('Player to revive', players, 0)
                rev.show(player).then((respond) => {
                    if (respond.isCanceled) return;
                    try {
                        player.runCommandAsync(`clear @s unitx:revive_soul 0 1`)
                    } catch (error) {
                        player.sendMessage(`§cA soul is requred!`)
                        return
                    }
                    let r = respond.formValues
                    players_data[r[0]].sendMessage(`§a${players[r[0]]} has been revived!`)
                    players_data[r[0]].runCommandAsync(`gamemode s @s`)
                    players_data[r[0]].runCommandAsync(`event entity @s unitx:health${World.getDynamicProperty("respawn_hearts")}`)
                    player.pro
                    players_data[r[0]].runCommandAsync(`playsound ambient.weather.thunder @a`)
                    World.playSound("ambient.weather.thunder")
                    players_data[r[0]].removeTag("spectorator")
                    player.sendMessage(`§7You have revived §a${players[r[0]]}`)
                    players_data[r[0]].teleport(new Mc.Location(0, 320, 0))
                    players_data[r[0]].addEffect(Mc.MinecraftEffectTypes.resistance, 10, 255, false)
                })
            }
        })
    }
}))
World.events.blockPlace.subscribe((eventData) => {
    if (eventData.block.typeId !== "unitx:revive_beacon") return
    let layer_read = World.getDynamicProperty("beacon_base")
    for (let i = 0; i < World.getDynamicProperty("beacon_base"); i++) {
        let blocks = blocksBetween(eventData.block.location.x - layer_read, eventData.block.location.y - layer_read, eventData.block.location.z - layer_read, eventData.block.location.x + layer_read, eventData.block.location.y - layer_read, eventData.block.location.z + layer_read)
        for (let i = 0; i < blocks.length; i++) {
            let block = World.getDimension("overworld").getBlock(new Mc.Vector(blocks[i][0], blocks[i][1], blocks[i][2])).typeId
            if (!((block == "minecraft:gold_block") || (block == "minecraft:iron_block") || (block == "minecraft:diamond_block") || (block == "minecraft:emerald_block") || (block == "minecraft:netherite_block"))) {
                return
            }
        }
        layer_read--
    }
    eventData.block.dimension.runCommandAsync(`playsound beacon.activate @a ${eventData.block.location.x} ${eventData.block.location.y} ${eventData.block.location.z}`)
})
function blocksBetween(x1, y1, z1, x2, y2, z2) {
    const locations = []
    for (let i = x1; i <= x2; i++) {
        for (let i2 = z1; i2 <= z2; i2++) {
            locations.push([i, y1, i2])
        }
    }
    return locations
}